﻿#include <stdio.h>
#include <stdint.h>

// chapter2
int add_int(int x, int y);
int add_int2(int x, int y);
int64_t add_int64(int64_t x, int64_t y);
int sub_int(int x, int y);
int mul_int(int x, int y);
int mul_int2(int x, int y);
int div_int(int x, int y);
int mod_int(int x, int y);
double add_double(double x, double y);
double sub_double(double x, double y);
double mul_double(double x, double y);
double div_double(double x, double y);

// chapter3
double area_circle(double x);
int days_of_january();
int days_of_february();
int days_of_month(int x);
int add_int_lea(int x, int y);
int sum_array(int* a);
int sum_array2(int* a);

// chapter4
int min(int x, int y);
int max(int x, int y);
int min2(int x, int y, int z);
int max2(int x, int y, int z);
int power(int x, int y);
int sum_loop(int* a, int n);

// chapter5
int min_call(int a, int b, int c, int d);
int min_call2(int a, int b, int c, int d, int e);
int average(int* a, int n);
int average2(int* a, int n);
int average3(int* a, int n);
int gcd(int x, int y);
int gcd2(int x, int y);

int main(void) {

	printf("---------------------------------------- chapter2\n");
	printf("add_int(1, 2): %d\n", add_int(1, 2));
	printf("add_int2(1, 2): %d\n", add_int2(1, 2));
	printf("add_int(-1, 2): %d\n", add_int(-1, 2));
	printf("add_int(-1, 1): %d\n", add_int(-1, 1));
	printf("add_int(-1, -2): %d\n", add_int(-1, -2));
	printf("add_int(1000000000, 2000000000): %d\n", add_int(1000000000, 2000000000));
	printf("add_int64(1000000000, 2000000000): %lld\n", add_int64(1000000000, 2000000000));
	printf("sub_int(7, 3): %d\n", sub_int(7, 3));
	printf("mul_int(7, 3): %d\n", mul_int(7, 3));
	printf("mul_int2(7, 3): %d\n", mul_int2(7, 3));
	printf("div_int(7, 3): %d\n", div_int(7, 3));
	printf("mod_int(7, 3): %d\n", mod_int(7, 3));
	printf("add_double(1.1, 2.2): %g\n", add_double(1.1, 2.2));
	printf("sub_double(5.5, 2.2): %g\n", sub_double(5.5, 2.2));
	printf("mul_double(5.5, 2.2): %g\n", mul_double(5.5, 2.2));
	printf("div_double(5.5, 2.2): %g\n", div_double(5.5, 2.2));

	printf("---------------------------------------- chapter3\n");
	printf("area_circle(1.2): %g\n", area_circle(1.2));
	printf("days_of_january: %d\n", days_of_january());
	printf("days_of_february: %d\n", days_of_february());
	printf("days_of_month(1): %d\n", days_of_month(1));
	printf("days_of_month(2): %d\n", days_of_month(2));
	printf("days_of_month(3): %d\n", days_of_month(3));
	printf("days_of_month(4): %d\n", days_of_month(4));
	printf("add_int_lea(1, 2): %d\n", add_int_lea(1, 2));
	printf("sum_array((int[]){110, 220, 330}): %d\n", sum_array((int[]){110, 220, 330}));
	printf("sum_array2((int[]){110, 220, 330, 440, 550}): %d\n", sum_array2((int[]){110, 220, 330, 440, 550}));

	printf("---------------------------------------- chapter4\n");
	printf("min(1, 2): %d\n", min(1, 2));
	printf("min(4, 3): %d\n", min(4, 3));
	printf("max(4, 3): %d\n", max(4, 3));
	printf("max(1, 2): %d\n", max(1, 2));
	printf("min2(1, 2, 3): %d\n", min2(1, 2, 3));
	printf("min2(6, 5, 4): %d\n", min2(6, 5, 4));
	printf("max2(6, 5, 4): %d\n", max2(6, 5, 4));
	printf("max2(1, 2, 3): %d\n", max2(1, 2, 3));
	printf("power(2, 4): %d\n", power(2, 4));
	printf("power(3, 5): %d\n", power(3, 5));
	printf("sum_loop((int[]){110, 220, 330}, 3): %d\n", sum_loop((int[]){110, 220, 330}, 3));
	printf("sum_loop((int[]){110, 220, 330, 440, 550}, 5): %d\n", sum_loop((int[]){110, 220, 330, 440, 550}, 5));

	printf("---------------------------------------- chapter5\n");
	printf("min_call(1, 2, 3, 4): %d\n", min_call(1, 2, 3, 4));
	printf("min_call(8, 7, 6, 5): %d\n", min_call(8, 7, 6, 5));
	printf("min_call2(1, 2, 3, 4, 5): %d\n", min_call2(1, 2, 3, 4, 5));
	printf("min_call2(9, 8, 7, 6, 5): %d\n", min_call2(9, 8, 7, 6, 5));
	printf("average((int[])[110, 220, 330], 3): %d\n", average((int[]){110, 220, 330}, 3));
	printf("average2((int[])[110, 220, 330], 3): %d\n", average2((int[]){110, 220, 330}, 3));
	printf("average3((int[])[110, 220, 330], 3): %d\n", average3((int[]){110, 220, 330}, 3));
	printf("gcd(18, 12): %d\n", gcd(18, 12));
	printf("gcd(39, 65): %d\n", gcd(39, 65));
	printf("gcd2(18, 12): %d\n", gcd2(18, 12));
	printf("gcd2(39, 65): %d\n", gcd2(39, 65));

	return 0;
}
